<template>
  <div
    class="w-full sticky left-0 z-20"
    style="top: var(--mobile-header-height, 52px)"
  >
    <div ref="headerRef" class="w-full bg-2">
      <BannerMobileRender actived-tab="home" :banner-keys="bannerKeys" />
    </div>
    <div
      v-if="!announcement.IsHidden"
      class="announcement py-2 bg-background1 h-[32px] pl-4 overflow-hidden"
    >
      <div class="container flex items-center h-full mx-auto">
        <utils-announcement :announcement="announcement.Text" />
      </div>
    </div>
  </div>
  <div class="px-2 render-wrapper geometry-container l-1350">
    <div class="z-1 w-full">
      <MobileGeometryLobbySidebar :menu-tab-headers="menuTabHeaders" />
      <div class="pl-12">
        <MobileGeometryLobbyList
          :game-entry-selected="gameEntrySelected"
          :providers="providers"
          :handle-game-entry-open-window="handleGameEntryOpenWindow"
        />
      </div>
    </div>
  </div>
</template>

<script setup lang="ts">
import { useElementSize } from "@vueuse/core";
import { handleGameEntryOpenWindow } from "@/composables/useTheme";
import { IThemePropertiesFromApi } from "~~/models/companyThemePropertiesRespone";
import { store } from "~~/store";
const { menuTabHeaders } = useHeaderComponent();
const { gameEntrySelected } = useGameEntryBaseOnTabSelected();
const { providers } = useGameEntryComponent();

const headerRef = ref();

const { height } = useElementSize(headerRef);

const themeProperties = computed(
  () => store.state.companyThemePropertiesFromApi.ThemeProperties
);

const announcement = computed(
  (): IThemePropertiesFromApi =>
    themePropertyHelper.getSingleThemeProperty(
      themeProperties.value,
      "announcement"
    )
);

watch(
  height,
  () => {
    document.documentElement.style.setProperty(
      "--mobile-banner-height",
      `${height.value}px`
    );
  },
  {
    immediate: true,
    deep: true,
  }
);
watch(
  () => announcement.value.IsHidden,
  (IsHidden) => {
    if (!IsHidden) {
      document.documentElement.style.setProperty(
        "--mobile-announcement-height",
        "32px"
      );
    }
  },
  {
    immediate: true,
  }
);
const { name } = useRoute();
onBeforeMount(() => {
  if (name === "index") {
    if (menuTabHeaders.value.length) {
      const menu = menuTabHeaders.value[0];
      if (menu.TabURL) {
        useRouter().push(menu.TabURL);
      }
    } else {
      useRouter().push("/");
    }
  }
});
const bannerKeys: Record<string, string> = {
  home: "lobby_banner_",
  sports: "sport_banner_",
  virtualsports: "virtual_sport_banner_",
  livecasino: "live_casino_banner_",
  games: "game_banner_",
  poker: "poker_banner_",
  lottery: "lottery_banner_",
  cockfight: "cockfight_banner_",
  promotion: "promotion_banner_",
};
</script>

<style lang="scss">
.render-wrapper {
  --bg-base-color: var(--background5);
  --bg-opacity: 0.35;
  position: relative;
  z-index: 2;
}

.geometry-container {
  &:before {
    --bg-base-color: var(--background5);
    --bg-opacity: 0.35;

    content: "";
    position: fixed;
    width: 100%;
    height: 100%;
    left: 0;
    top: calc(
      var(--mobile-header-height, 0) + var(--mobile-banner-height, 0) +
        var(--mobile-announcement-height, 0)
    );
    background: linear-gradient(
        0deg,
        rgba(var(--bg-light-overlay), var(--bg-opacity)),
        rgba(var(--bg-light-overlay), var(--bg-opacity))
      ),
      linear-gradient(0deg, var(--bg-base-color), var(--bg-base-color)) !important;
    z-index: 0;
  }
}
</style>
